---
title: The Firefox JavaScript Debugger
slug: Tools/Debugger
tags:
  - Debugger
  - Debugging
  - Dev Tools
  - JavaScript
  - Tools
  - 'l10n:priority'
---
<div>{{ToolsSidebar}}</div>

<p>The JavaScript Debugger enables you to step through JavaScript code and examine or modify its state to help track down bugs.</p>

<p>{{EmbedYouTube("QK4hKWmJVLo")}}</p>

<p>You can use it to debug code running locally in Firefox or running remotely, for example on an Android device running Firefox for Android. See <a href="/en-US/docs/Tools/Remote_Debugging">remote debugging </a>to learn how to connect the debugger to a remote target.</p>

<p>To find your way around the debugger, here's a <a href="/en-US/docs/Tools/Debugger/UI_Tour">quick tour of the UI</a>.</p>

<h2 id="How_to">How to</h2>

<p>To find out what you can do with the debugger, refer to the following how-to guides.</p>

<div class="twocolumns">
<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Open_the_debugger">Open the debugger</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Pretty-print_a_minified_file">Pretty-print a minified file</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Search">Search</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Use_a_source_map">Use a source map</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers#Debugging_worker_threads">Debug worker threads</a></li>
</ul>
</div>

<h3 id="Pause_execution">Pause execution</h3>

<p>You probably want to pause the execution of your code, in order to see what is going on at various points. There are multiple ways to tell the Debugger how and when to pause:</p>

<div class="twocolumns">
<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint">Set a breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_conditional_breakpoint">Set a conditional breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/Set_an_XHR_breakpoint">Set an XHR breakpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/Set_event_listener_breakpoints">Set event listener breakpoints</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Breaking_on_exceptions">Break on exceptions</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Use_watchpoints">Use watchpoints for property reads and writes</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/Break_on_DOM_mutation">Break on DOM Mutation</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Disable_breakpoints">Disable breakpoints</a></li>
</ul>
</div>

<h3 id="Control_execution">Control execution</h3>

<p>What can you do after execution pauses?</p>

<div class="twocolumns">
<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Step_through_code">Step through code</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Black_box_a_source">Black box a source</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/Debug_worker_threads">Debug worker threads</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Debug_eval_sources">Debug eval sources</a></li>
</ul>
</div>

<h3 id="Look_at_values">Look at values</h3>

<p>You probably want to see the value of variables or expressions, either during execution or when it is paused.</p>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger/Set_a_logpoint">Set a logpoint</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_Watch_Expressions">Set watch expressions</a></li>
</ul>

<hr>
<h2 id="Reference">Reference</h2>

<ul>
 <li>
  <p><a href="/en-US/docs/Tools/Debugger/Keyboard_shortcuts">Keyboard shortcuts</a></p>
 </li>
 <li>
  <p><a href="/en-US/docs/Tools/Debugger/Source_map_errors">Source map errors</a></p>
 </li>
</ul>
